/* PREAMBLE.H
*/

/*??=pragma filetag("IBM-284") */

# ifndef PREAMBLE_H
# define PREAMBLE_H

# include "cc.h"
# include "preccx.h"

/* an internal buffer which holds C function argument lists */

# define SMALLBUFFERSIZE 365



extern P_VOID  __cdecl initagent(AGENT *,char *, int);
extern CHARS __cdecl putagent(AGENT *,char);
extern CHARS __cdecl nputagent(AGENT *,CHARS);
extern CHARS __cdecl getagent(AGENT *,CHARS*);
extern CHARS __cdecl resetagent(AGENT *);
extern CHARS __cdecl myputchar(int);
extern CHARS __cdecl getname(CHARS*);
extern CHARS __cdecl putname(CHARS);
extern CHARS __cdecl putargs(CHARS);
extern CHARS __cdecl getargs(CHARS*);
extern CHARS __cdecl putmeta(CHARS);
extern CHARS __cdecl getmeta(CHARS*);
extern CHARS __cdecl putkeys(CHARS);
extern CHARS __cdecl getkeys(CHARS*);

extern AGENT chars;
extern AGENT namE;
extern AGENT args;
extern AGENT keys;
extern AGENT meta;
extern int nid;

extern CHARS __cdecl UNSETNAME(CHARS);
extern CHARS __cdecl GARGS(CHARS);
extern CHARS __cdecl GNAME(CHARS);
extern CHARS __cdecl CATFUNCARGS(CHARS,CHARS);
extern P_VOID  __cdecl GETNEWNAME(CHARS*,CHARS);
extern P_VOID  __cdecl GETANAME(CHARS*,CHARS,CHARS,int);
extern int   __cdecl is_in(char *,char *);
extern P_BOOLEAN __cdecl ISEMPTY(CHARS);

extern char * __cdecl p_scpy(CHARS,CHARS);

extern void  __cdecl p_creat_intern_data();
extern void  __cdecl p_destr_intern_data();

void __cdecl resetall();

extern int      precc_yytchar;
extern int      precc_yylineno;
extern int      precc_yylen;
extern int __cdecl precc_yylex();
extern char    *precc_yylloc;
extern VALUE    precc_yylval;
extern int __cdecl precc_yywrap();

# endif

